<template>
  <v-timeline
    align="start"
    side="start"
    dot-color="grey"
    size="16"
    density="comfortable"
    class="font-light leading-none [&_.v-timeline-divider\_\_inner-dot]:!transition-all"
  >
    <v-timeline-item :dot-color="objectSectionColor">
      <section
        class="pb-4 transition-all"
        :style="{ 'color': objectSectionColor }"
      >
        Объект
      </section>
    </v-timeline-item>

    <v-timeline-item :dot-color="rateSectionColor">
      <section
        class="pb-4 transition-all"
        :style="{ 'color': rateSectionColor }"
      >
        Тариф
      </section>
    </v-timeline-item>

    <v-timeline-item :dot-color="guestsSectionColor">
      <section
        class="pb-4 transition-all"
        :style="{ 'color': guestsSectionColor }"
      >
        Гости
      </section>
    </v-timeline-item>

    <v-timeline-item :dot-color="amenitiesSectionColor">
      <section
        class="pb-4 transition-all"
        :style="{ 'color': amenitiesSectionColor }"
      >
        Услуги
      </section>
    </v-timeline-item>

    <v-timeline-item :dot-color="correctionsSectionColor">
      <section
        class="pb-4 transition-all"
        :style="{ 'color': correctionsSectionColor }"
      >
        Коррекции
      </section>
    </v-timeline-item>

    <v-timeline-item :dot-color="commentSectionColor">
      <section
        class="pb-4 transition-all"
        :style="{ 'color': commentSectionColor }"
      >
        Комментарий
      </section>
    </v-timeline-item>
  </v-timeline>
</template>

<script setup lang="ts">
import { computed } from 'vue';

const props = defineProps<{ booking: INewBooking; }>();

const NEUTRAL_COLOR = 'grey';
const ERROR_COLOR = '#a8000f';
const SUCCESS_COLOR = 'var(--tw-color-teal-600)';

const objectSectionColor = computed(() => {
  const isObjectSelected = (
    Boolean(props.booking.property) &&
    Boolean(props.booking.dates)
  );

  return isObjectSelected ? SUCCESS_COLOR : ERROR_COLOR;
});

const rateSectionColor = computed(() => {
  const isRateSelected = Boolean(props.booking.rate);
  return isRateSelected ? SUCCESS_COLOR : ERROR_COLOR;
});

const guestsSectionColor = computed(() => {
  const isContactSelected = Boolean(props.booking.guests.contact);
  const isAdultsFilled = props.booking.guests.count.adults > 0;

  return isContactSelected && isAdultsFilled
    ? SUCCESS_COLOR
    : ERROR_COLOR;
});

const amenitiesSectionColor = computed(() => {
  const isAmenitiesSelected = props.booking.amenities.length > 0;
  return isAmenitiesSelected ? SUCCESS_COLOR : NEUTRAL_COLOR;
});

const correctionsSectionColor = computed(() => {
  const isCorrectionsSelected = props.booking.corrections.length > 0;
  return isCorrectionsSelected ? SUCCESS_COLOR : NEUTRAL_COLOR;
});

const commentSectionColor = computed(() => {
  const isCommentFilled = Boolean(props.booking.comment);
  return isCommentFilled ? SUCCESS_COLOR : NEUTRAL_COLOR;
});
</script>